Page MenuHomePhabricator

Mentee overview Vue: Once added, edit count-based filtering cannot be removed
Closed, ResolvedPublicBUG REPORT

Description

Steps to replicate the issue (include links if applicable):

  1. Ensure wgGEMentorDashboardUseVue is true (currently, beta cluster)
  2. Go to Special:MentorDashboard
  3. Open Filters dropdown
  4. Under Edit count, add an arbitrary non-zero positive integer to Minimum and Maximum fields. Confirm by clicking Update.
  5. Open Filters dropdown again
  6. Remove the numbers added in step 4.
  7. Click Update

What happens?:

The filtering dropdown interprets empty string as zeros, which can be confirmed by re-opening the dropdown again:

image.png (542×604 px, 18 KB)

Only mentees with exactly zero edits are shown.

What should have happened instead?:

The filter dropdown interprets empty strings as "filter is not used". The module displays mentees with any editcount.

Software version (skip for WMF-hosted wikis like Wikipedia): Reproduced locally as of d1320d7c. Can be reproduced on beta as well.

Notes: IMO, this is a blocker for a non-testwiki deployment of the Vue dialog.

Event Timeline

kostajh triaged this task as High priority.Jul 18 2022, 7:20 PM
kostajh edited projects, added Growth-Team (Current Sprint); removed Growth-Team.

Change 815695 had a related patch set uploaded (by Sergio Gimeno; author: Sergio Gimeno):

[mediawiki/extensions/GrowthExperiments@master] Mentee overview(vue): allow to set empty values for edit count filters

https://gerrit.wikimedia.org/r/815695

Sgs changed the task status from Open to In Progress.Jul 20 2022, 10:45 AM
Sgs moved this task from Incoming to In Progress on the Growth-Team (Current Sprint) board.

Change 815695 merged by jenkins-bot:

[mediawiki/extensions/GrowthExperiments@master] MentorDashboard.Vue: allow setting empty values for edit count filters

https://gerrit.wikimedia.org/r/815695

Sgs changed the task status from In Progress to Open.Jul 20 2022, 1:18 PM
Sgs moved this task from Code Review to QA on the Growth-Team (Current Sprint) board.

@Urbanecm_WMF - please review the following:

(1)

The filtering dropdown interprets empty string as zeros, which can be confirmed by re-opening the dropdown again:

I assumed this as a reasonable default fallback for entering an empty string.

(2)

What should have happened instead?:
The filter dropdown interprets empty strings as "filter is not used". The module displays mentees with any editcount.

  • some user with zero edits might have non-zero number of questions/reverts/blocks - and a mentor might be interested to see them on MentorDashboard. Right now there is no way to display such users, i.e. with zero edits + non-zero number of questions/reverts/blocks.
  • when a mentor enters 0 (zero), there is no indication that it's non-valid input, but newcomers with zero edits won't be displayed. When filters are re-opened, the 0 (zero) input is not displayed, which might be confusing to users.

mentordashboard_zero.gif (714×676 px, 142 KB)

  • my mentor test user (on enwiki betalabs ET402) won't see users who registered less two weeks ago and haven't done any edits.
(enwiki)>  select gemm_mentee_id, user_name, user_registration, user_editcount  from growthexperiments_mentor_mentee join user on gemm_mentee_id=user_id  where gemm_mentor_id=66675 and user_registration >='20220715162016'and user_editcount=0;
+----------------+------------------+-------------------+----------------+
| gemm_mentee_id | user_name        | user_registration | user_editcount |
+----------------+------------------+-------------------+----------------+
|          94633 | AdrianNxe1225    | 20220720145342    |              0 |
|          94681 | JacquelynCummins | 20220721135048    |              0 |
|          94751 | VWalters         | 20220722185422    |              0 |
|          94806 | WilburnManson11  | 20220724135512    |              0 |
|          94846 | SanfordBarge277  | 20220725002910    |              0 |
|          94892 | Michailmvx       | 20220725162817    |              0 |
|          94897 | IsobelBeak38162  | 20220725233523    |              0 |
+----------------+------------------+-------------------+----------------+
7 rows in set (0.002 sec)

The filter selection on Special:MentorDashboard is - 0-500 edits for last 6 months. There will be one exception - JacquelynCummins because that user was claimed via Special:ClaimMentee.

Screen Shot 2022-07-29 at 8.52.02 PM.png (1×1 px, 151 KB)

@Urbanecm_WMF - please review the following:

(1)

The filtering dropdown interprets empty string as zeros, which can be confirmed by re-opening the dropdown again:

I assumed this as a reasonable default fallback for entering an empty string.

I'd agree, but IMO, users should be able to remove a filter. It'd be possible to use 0-9999999999999999999999999999 (or similarly high number), but I think removing the filter by inserting empty strings is more obvious.

(2)

What should have happened instead?:
The filter dropdown interprets empty strings as "filter is not used". The module displays mentees with any editcount.

  • some user with zero edits might have non-zero number of questions/reverts/blocks - and a mentor might be interested to see them on MentorDashboard. Right now there is no way to display such users, i.e. with zero edits + non-zero number of questions/reverts/blocks.

Per below, I think the module should support a zero in the edit count filter.

  • when a mentor enters 0 (zero), there is no indication that it's non-valid input, but newcomers with zero edits won't be displayed. When filters are re-opened, the 0 (zero) input is not displayed, which might be confusing to users.

Thanks for catching this! I think zero should be a valid input, to let mentors to see information about their newcomers who are yet to make their first edit. I think the behavior should be:

  • User enters zero for the filter: Only users with zero edits are shown (filter gets applied, zero is the value)
  • User enters an empty string for the filter: No limit is applied (filter does not kick in)

In practice, the difference will be only meaningful for the "Maximum" field (as editcounts are at least 0), to let you represent both "mentees with any number of edits" and "mentees with exactly zero edits.

@Sgs I'm not sure if this is caused by the fix you uploaded as part of this task, or a new bug. Happy to fill a new task if that'd make things easier!

mentordashboard_zero.gif (714×676 px, 142 KB)

  • my mentor test user (on enwiki betalabs ET402) won't see users who registered less two weeks ago and haven't done any edits.
(enwiki)>  select gemm_mentee_id, user_name, user_registration, user_editcount  from growthexperiments_mentor_mentee join user on gemm_mentee_id=user_id  where gemm_mentor_id=66675 and user_registration >='20220715162016'and user_editcount=0;
+----------------+------------------+-------------------+----------------+
| gemm_mentee_id | user_name        | user_registration | user_editcount |
+----------------+------------------+-------------------+----------------+
|          94633 | AdrianNxe1225    | 20220720145342    |              0 |
|          94681 | JacquelynCummins | 20220721135048    |              0 |
|          94751 | VWalters         | 20220722185422    |              0 |
|          94806 | WilburnManson11  | 20220724135512    |              0 |
|          94846 | SanfordBarge277  | 20220725002910    |              0 |
|          94892 | Michailmvx       | 20220725162817    |              0 |
|          94897 | IsobelBeak38162  | 20220725233523    |              0 |
+----------------+------------------+-------------------+----------------+
7 rows in set (0.002 sec)

The filter selection on Special:MentorDashboard is - 0-500 edits for last 6 months. There will be one exception - JacquelynCummins because that user was claimed via Special:ClaimMentee.

Screen Shot 2022-07-29 at 8.52.02 PM.png (1×1 px, 151 KB)

Unfortunately, I don't see this image (F35359355), and it looks like it has some context to understand this issue better.

Screen Shot 2022-07-29 at 8.52.02 PM.png (1×1 px, 151 KB)

Unfortunately, I don't see this image (F35359355), and it looks like it has some context to understand this issue better.

The image seems to be public, let me know if it's still not visible. With the image I was trying to illustrate the discrepancy between what a query for mentees with zero edits and the registration date fetches and what the UI displays (i.e. no users with zero edits). The only user with zero edits - JacquelynCummins - is displayed because that user was claimed.

(enwiki)>  select gemm_mentee_id, user_name, user_registration, user_editcount  from growthexperiments_mentor_mentee join user on gemm_mentee_id=user_id  where gemm_mentor_id=66675 and user_registration >='20220715162016'and user_editcount=0;

Screen Shot 2022-07-29 at 8.52.02 PM.png (1×1 px, 151 KB)

Testing notes (what to test after the fix(es)):

What should have happened instead?:

The filter dropdown interprets empty strings as "filter is not used". The module displays mentees with any editcount.

(1)

The filter drop-down interprets empty strings as "filter is not used".

  • there are default values for filters: Minimum: 1 Maximum: 500 - should they be displayed? Or the previous user's filter?
  • the filter preserves 0 as a user's input

Current behavior on testwiki wmf.23:

  • user Etonkoviova (a mentor) sees two users with default Min/Max: (1-500)
    Screen Shot 2022-08-05 at 12.00.54 PM.png (484×1 px, 66 KB)
  • the mentor changes Min/Max (16-500) - one user is displayed:

Screen Shot 2022-08-05 at 12.03.30 PM.png (600×1 px, 73 KB)

  • the mentor removes any values for Min/Max fields - the fields are empty; clicks Update - three users are displayed (Maximum field is set to unlimited value?)

Screen Shot 2022-08-05 at 12.04.54 PM.png (758×1 px, 111 KB)

  • the user re-opens the filters - the Min/Max fields are empty:

Screen Shot 2022-08-05 at 12.06.40 PM.png (1×1 px, 121 KB)

(2)

The module displays mentees with any edit count.

  • make sure that automatically assigned users with zero counts are displayed

Change 821271 had a related patch set uploaded (by Sergio Gimeno; author: Sergio Gimeno):

[mediawiki/extensions/GrowthExperiments@master] Mentee overview(vue): allow zero as edit count filter value

https://gerrit.wikimedia.org/r/821271

Change 821271 merged by jenkins-bot:

[mediawiki/extensions/GrowthExperiments@master] Mentee overview(vue): allow zero as edit count filter value

https://gerrit.wikimedia.org/r/821271

Change 819647 had a related patch set uploaded (by Sergio Gimeno; author: Sergio Gimeno):

[mediawiki/extensions/GrowthExperiments@master] Mentee overview(vue): use number input for the edit count filters

https://gerrit.wikimedia.org/r/819647

Sgs changed the task status from Open to In Progress.Aug 9 2022, 5:43 PM
Urbanecm_WMF changed the task status from In Progress to Open.Aug 11 2022, 5:38 PM
Urbanecm_WMF moved this task from Code Review to QA on the Growth-Team (Current Sprint) board.

Change 819647 merged by jenkins-bot:

[mediawiki/extensions/GrowthExperiments@master] Mentee overview(vue): use number input for the edit count filters

https://gerrit.wikimedia.org/r/819647

Checked on testwiki wmf.25 (the test scenarios in https://phabricator.wikimedia.org/T313263#8134417) - works as expected.